import { takeEvery, call, put } from "redux-saga/effects";
import { GET_USER_BY_ID } from "../actionTypes";
import * as actions from "../actions/auth";

import axios from "axios";

const userUrl = "http://subdomain.entony.fs.a-level.com.ua/api/users/";

function* getUserById({ payload }) {
	// console.log("USERS TYPES SAGA");
	try {
		const { data } = yield call(axios, {
			method: "GET",
			url: userUrl + payload.id,
			headers: {
				Authorization: `Bearer ${payload.token}`
			}
		});

		yield put(actions.getUserByIdSuccess(data));
	} catch (error) {
		yield put(actions.getUserByIdFail(error));
	}
}

export function* users() {
	yield takeEvery(GET_USER_BY_ID, getUserById);
}
